Skip to content

Modify user information

This document is automatically generated based on https://github.com/authing/authing-docs-factory based on https://api-explorer.genauth.ai V3 API, and is consistent with API parameters and return results. If the document description is incorrect, please refer to V3 API.

Modify user information through user ID. Email, mobile number, user name, externalId are unique in the user pool. This interface will modify user information as an administrator, so there is no need to perform security checks such as mobile number verification code verification.

Method name

ManagementClient.updateUser

Request parameters

NameTypeRequiredDefault valueDescriptionSample value
userIdstringYes-The unique identifier of the user, which can be user ID, user name, email address, mobile phone number, externalId, or ID in an external identity source. For details, see the description of the userIdType field. The default is user id.6229ffaxxxxxxxxcade3e3d9
phoneCountryCodestringNo-Mobile phone area code. This field is optional for mainland China mobile phone numbers. The GenAuth SMS service does not yet support international mobile phone numbers. You need to configure the corresponding international SMS service in the GenAuth console. For a complete list of mobile phone area codes, please refer to https://en.wikipedia.org/wiki/List_of_country_calling_codes.+86
namestringNo-User's real name, not uniqueZhang San
nicknamestringNo-NicknameZhang San
photostringNo-Avatar linkhttps://files.authing.co/authing-console/default-user-avatar.png
externalIdstringNo-Third-party external ID10010
statusstringNoActivatedCurrent account statusActivated
emailVerifiedbooleanno-Is the email address verified?true
phoneVerifiedbooleanno-Is the phone number verified?true
birthdatestringno-Date of birth2022-06-03
countrystringno-CountryCN
provincestringno-ProvinceBJ
citystringno-CityBJ
addressstringno-AddressBeijing Chaoyang
streetAddressstringno-Street addressBeijing Chaoyang District xxx Street
postalCodestringno-Postal code438100
genderstringnoUGenderM
usernamestringNo-Username, unique in the user poolbob
emailstringNo-Email address, case-insensitivetest@example.com
phonestringNo-Phone number without area code. If it is a foreign phone number, please specify the area code in the phoneCountryCode parameter.188xxxx8888
passwordstringNo-User password, in plain text by default. We use the HTTPS protocol to securely transmit passwords, which can ensure security to a certain extent. If you need a higher level of security, we also support RSA256 and SM2 to encrypt passwords. See the passwordEncryptType parameter for details.passw0rd
companystringno-Companysteamory
browserstringno-Last login browser UAMozilla/5.0 (Linux; Android 10; V2001A; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/87.0.4280.141 Mobile Safari/537.36 VivoBrowser/10.2.10.0
devicestringno-Last login deviceiOS
givenNamestringno-First namexx
familyNamestringno-Last namexx
middleNamestringno-Middle nameJames
profilestringno-Preferred Usernamealice
preferredUsernamestringno-Preferred Usernamealice
websitestringno-User personal websitehttps://my-website.com
zoneinfostringno-User time zone informationGMT-08:00
localestringno-Localeaf
formattedstringno-Full standard address132, My Street, Kingston, New York 12401.
regionstringno-User locationXinjiang Uyghur Autonomous Region
identityNumberstringno-User ID number420421xxxxxxxx1234
customDataobjectno-For custom data, the key in the passed object must first define the relevant custom fields in the user pool.{"school":"Peking University","age":22}
metadataobjectNo-Data object data, the key in the passed object must first be in the user data object related custom field{"school":"Peking University","age":22}
options<a UpdateUserOptionsDtoNo-Optional parameters{"autoGeneratePassword":true,"resetPasswordOnFirstLogin":true,"passwordEncryptType":"none"}

Sample code

ts
import { ManagementClient, Models } from "authing-node-sdk";

// Initialize ManagementClient
const managementClient = new ManagementClient({
  // Need to be replaced with your GenAuth Access Key ID
  accessKeyId: "GEN_AUTH_ACCESS_KEY_ID",
  // Need to be replaced with your GenAuth Access Key Secret
  accessKeySecret: "GEN_AUTH_ACCESS_KEY_SECRET",
  // If it is a private deployment customer, you need to set the GenAuth service domain name
  // host: 'https://api.your-authing-service.com'
});

(async () => {
  const result = await managementClient.updateUser({
    // Replace user ID
    userId: "6229ffaxxxxxxxxcade3e3d9",
    name: "xxx",
    nickname: "xxxx",
  });

  console.log(JSON.stringify(result, null, 2));
})();

Request response

Type: UserSingleRespDto

NameTypeDescription
statusCodenumberBusiness status code, you can use this status code to determine whether the operation is successful, 200 Indicates success.
messagestringDescription
apiCodenumberSegmented error code, which can be used to get the specific error type (not returned for successful requests). For a detailed list of error codes, see: API Code List
requestIdstringRequest ID. Returned when the request fails.
data<a UserDtoResponse data

Sample result:

json
{
  "statusCode": 200,
  "message": "Operation successful",
  "requestId": "934108e5-9fbf-4d24-8da1-c330328abd6c",
  "data": {
    "userId": "6229ffaxxxxxxxxcade3e3d9",
    "createdAt": "2022-07-03T03:20:30.000Z",
    "updatedAt": "2022-07-03T03:20:30.000Z",
    "status": "Activated",
    "workStatus": "Active",
    "externalId": "10010",
    "email": "test@example.com",
    "phone": "188xxxx8888",
    "phoneCountryCode": "+86",
    "username": "bob",
    "name": "Zhang San",
    "nickname": "xxxx",
    "photo": "https://files.authing.co/authing-console/default-user-avatar.png",
    "loginsCount": 3,
    "lastLogin": "2022-07-03T03:20:30.000Z",
    "lastIp": "127.0.0.1",
    "gender": "M",
    "emailVerified": true,
    "phoneVerified": true,
    "passwordLastSetAt": "2022-07-03T03:20:30.000Z",
    "birthdate": "2022-06-03",
    "country": "CN",
    "province": "BJ",
    "city": "BJ",
    "address": "Beijing Chaoyang",
    "streetAddress": "Beijing Chaoyang District xxx Street",
    "postalCode": "438100",
    "company": "steamory",
    "browser": "Mozilla/5.0 (Linux; Android 10; V2001A; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/87.0.4280.141 Mobile Safari/537.36 VivoBrowser/10.2.10.0",
    "device": "iOS",
    "givenName": "xx",
    "familyName": "xx",
    "middleName": "James",
    "profile": "alice",
    "preferredUsername": "alice",
    "website": "https://my-website.com",
    "zoneinfo": "GMT-08:00",
    "locale": "af",
    "formatted": "132, My Street, Kingston, New York 12401.",
    "region": "Xinjiang Uyghur Autonomous Region",
    "userSourceType": "register",
    "passwordSecurityLevel": 1,
    "departmentIds": "[\"624d930c3xxxx5c08dd4986e\",\"624d93102xxxx012f33cd2fe\"]",
    "identities": {
      "identityId": "62299d8b866d2dab79a89dc4",
      "extIdpId": "6076bacxxxxxxxxd80d993b5",
      "provider": "wechat",
      "type": "openid",
      "userIdInIdp": "oj7Nq05R-RRaqak0_YlMLnnIwsvg",
      "accessToken": "57_fK0xgSL_NwVlS-gmUwlMQ2N6AONNIOAYxxxx",
      "refreshToken": "57_IZFu91Ak1Wg6DRytZFFIOd3upNF5lH7vPxxxxx",
      "originConnIds": "[\"605492ac41xxxxe0362f0707\"]"
    },
    "identityNumber": "420421xxxxxxxx1234",
    "customData": {
      "school": "xxx",
      "age": 22
    },
    "statusChangedAt": "2022-07-03T03:20:30.000Z"
  }
}

Data Structure

UpdateUserOptionsDto

NameTypeIs this field required?DescriptionSample value
userIdTypestringNoUser ID type, the default value is user_id, the optional values are:
- user_id: GenAuth user ID, such as 6319a1504f3xxxxf214dd5b7
- phone: user phone number
- email: user email
- username: username
- external_id: user ID in the external system, corresponding to the externalId field of GenAuth user information
- identity: user's external identity source information, in the format of <extIdpId>:<userIdInIdp>, where <extIdpId> is the ID of the GenAuth identity source, and <userIdInIdp> is the user's ID in the external identity source.
Example value: 62f20932716fbcc10d966ee5:ou_8bae746eac07cd2564654140d2a9ac61.
- sync_relation: User's external identity source information, in the format of <provier>:<userIdInIdp>, where <provier> is the type of sync identity source, such as wechatwork, lark; <userIdInIdp> is the user's ID in the external identity source.
Example value: lark:ou_8bae746eac07cd2564654140d2a9ac61.
user_id
resetPasswordOnFirstLoginbooleanNoSet the user to reset the password when logging in for the first time
resetPasswordOnNextLoginbooleanNoRequire password reset on next login
passwordEncryptTypestringNoPassword encryption type, supports RSA256 and SM2 algorithms. The default is none, no encryption.
- none: Do not encrypt the password, use plain text for transmission.
- rsa: Use RSA256 algorithm to encrypt the password, and need to use the RSA public key of GenAuth service for encryption. Please read the Introduction section to learn how to obtain the RSA256 public key of GenAuth service.
- sm2: Use SM2 algorithm to encrypt the password, and need to use the SM2 public key of GenAuth service for encryption. Please read the Introduction section to learn how to obtain the SM2 public key of GenAuth service.
sm2
autoGeneratePasswordbooleanNoWhether to automatically generate a password
sendPasswordResetedNotificationNoOptions for sending email and phone number when resetting password Nested type: <a SendResetPasswordNotificationDto.{"sendDefaultEmailNotification":false,"sendDefaultPhoneNotification":false,"inputSendEmailNotification":"test@example.com","inputSendPhoneNotification":"136xxxx1234","appId":"app1"}

SendResetPasswordNotificationDto

NameTypeIs it required?DescriptionSample value
sendDefaultEmailNotificationbooleanNoAfter resetting the password, whether to send the user's default email notification
sendDefaultPhoneNotificationbooleanNoAfter resetting the password, whether to send the user's default SMS notification
inputSendEmailNotificationstringNoWhen the user's password is changed, enter the email address to sendtest@example.com
inputSendPhoneNotificationstringNoWhen the user's password is changed, enter the mobile number to send183xxxx1234
appIdstringNoWhen sending the login address, the specified application id will send the login address of this application to the user's email or mobile number. The default is the login address of the user pool application panel.appid1

UserDto

NameTypeRequiredDescriptionSample value
userIdstringYesThe unique identifier of the user, which can be user ID, user name, email address, mobile phone number, externalId, or ID in an external identity source. For details, see the description of the userIdType field. The default is user id.6229ffaxxxxxxxxcade3e3d9
createdAtstringyescreation time2022-07-03T03:20:30.000Z
updatedAtstringyesupdate time2022-07-03T03:20:30.000Z
statusstringyescurrent status of the account:
- Activated: normal status
- Suspended: deactivated
- Deactivated: disabled
- Resigned: resigned
- Archived: archived
Suspended
workStatusstringyescurrent work status of the accountClosed
externalIdstringnothird-party external ID10010
emailstringnoemail address, case insensitivetest@example.com
phonestringNoPhone number without area code. If it is a foreign phone number, specify the area code in the phoneCountryCode parameter.188xxxx8888
phoneCountryCodestringNoMobile phone area code. This field is optional for mainland China phone numbers. The GenAuth SMS service does not yet support international phone numbers. You need to configure the corresponding international SMS service in the GenAuth console. For a complete list of mobile phone area codes, please refer to https://en.wikipedia.org/wiki/List_of_country_calling_codes.+86
usernamestringNoUsername, unique in the user poolbob
namestringNoUser's real name, not uniqueZhang San
nicknamestringNoNicknameZhang San
photostringNoAvatar linkhttps://files.authing.co/authing-console/default-user-avatar.png
loginsCountnumberNoTotal number of historical logins3
lastLoginstringNoLast login time2022-07-03T03:20:30.000Z
lastIpstringNoLast login IP127.0.0.1
genderstringYesGender:
- M: Male, male
- F: Female, female
- U: unknown, unknown
M
emailVerifiedbooleanyesEmail verifiedtrue
phoneVerifiedbooleanyesPhone number verifiedtrue
passwordLastSetAtstringnoUser's last password change time2022-07-03T03:20:30.000Z
birthdatestringNoDate of birth2022-06-03
countrystringNoCountryCN
provincestringNoProvinceBJ
citystringNoCityBJ
addressstringNoAddressBeijing Chaoyang
streetAddressstringNoStreet addressBeijing Chaoyang District xxx Street
postalCodestringNoPostal code438100
companystringNoCompanysteamory
browserstringNoLast browser used for login UAMozilla/5.0 (Linux; Android 10; V2001A; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/87.0.4280.141 Mobile Safari/537.36 VivoBrowser/10.2.10.0
devicestringnoThe device used when last logging iniOS
givenNamestringnoNamexx
familyNamestringnosurnamexx
middleNamestringnomiddle nameJames
profilestringnoPreferred Usernamealice
preferredUsernamestringnoPreferred Usernamealice
websitestringnoUser personal websitehttps://my-website.com
zoneinfostringnoUser time zone informationGMT-08:00
localestringnoLocaleaf
formattedstringnoFull standard address132, My Street, Kingston, New York 12401.
regionstringnoUser locationXinjiang Uyghur Autonomous Region
userSourceTypestringyesSource type:
- excel: Import via excel
- register: User self-registration
- adminCreated: Manual creation by the administrator (including creating users using the management API)
- syncTask: Synchronization task of the sync center
excel
userSourceIdstringNoApplication ID or synchronization task ID
lastLoginAppstringnoID of the application where the user last logged in
mainDepartmentIdstringnoID of the user's main department
lastMfaTimestringnoTime when the user last performed MFA authentication
passwordSecurityLevelnumbernoUser password security strength level1
resetPasswordOnNextLoginbooleannoRequire password reset on next login
registerSourcearraynoRegistration method
departmentIdsarraynoList of department IDs to which the user belongs["624d930c3xxxx5c08dd4986e","624d93102xxxx012f33cd2fe"]
identitiesarraynoExternal identity source Nested type: <a IdentityDto.
identityNumberstringNoUser ID number420421xxxxxxxx1234
customDataobjectNoUser's extended field data{"school":"Peking University","age":22}
postIdListarrayNoUser-associated department ID
statusChangedAtstringNoUser status last modified time2022-07-03T03:20:30.000Z
tenantIdstringNoUser tenant ID

Agent infrastructure for identity, memory, and web action.